/********************************************************************************
 * Copyright (c) Des Herriott 1993, 1994
 *               Erik Kunze   1995, 1996
 *               Jens Kilian  1998
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Des Herriott
 *         Erik Kunze
 *
 * changed by EKU
 * modified for BeZX JJK
 *******************************************************************************/

#ifndef _XZX_UTIL_H
#define _XZX_UTIL_H

/* $Id: util.h,v 3.0 1996/10/03 10:23:45 erik Exp $ */

#include "stdio.h"

/********************************************************************************
 * Defines
 *******************************************************************************/

/* Message types */
enum { XZX_INFO, XZX_WARN, XZX_PWARN, XZX_ERR, XZX_PERR, XZX_FATAL, XZX_DEBUG };

/********************************************************************************
 * Prototypes
 *******************************************************************************/

extern int topen(const char *, int, int);
extern FILE *tfopen(const char *, const char *, int);
extern FILE *tfreopen(const char *, const char *, FILE *, int);

extern FILE *OpenXzxFile(char *, char *, int);
extern void OnQuit(void (*)());
extern void Quit(int );
extern void XzxMesg(int , ...);
extern void IntFrequency(int, void (*)(void));

#endif /* ! _XZX_UTIL_H */

/* EOF *************************************************************************/
