/********************************************************************************
 * Copyright (c) Des Herriott 1993, 1994
 *               Erik Kunze   1995, 1996
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Des Herriott
 *         Erik Kunze
 *
 * changed by EKU
 *******************************************************************************/

#if !defined(NO_RCSID) && !__cplusplus
static char xxcbops_c[] = "$Id: z80_xxcbops.c,v 3.0 1996/10/03 10:22:03 erik Exp $";
#endif

/********************************************************************************
 * xxcbops.c - Indexed operations prefixed by 0xCB.
 *******************************************************************************/

/* rlc (xx+d),b */
case 0x00:
	Tstates += 23;
	B = RD_BYTE(XX);
	RLC(B);
	WR_BYTE(XX, B);
	break;

/* rlc (xx+d),c */
case 0x01:
	Tstates += 23;
	C = RD_BYTE(XX);
	RLC(C);
	WR_BYTE(XX, C);
	break;

/* rlc (xx+d),d */
case 0x02:
	Tstates += 23;
	D = RD_BYTE(XX);
	RLC(D);
	WR_BYTE(XX, D);
	break;

/* rlc (xx+d),e */
case 0x03:
	Tstates += 23;
	E = RD_BYTE(XX);
	RLC(E);
	WR_BYTE(XX, E);
	break;

/* rlc (xx+d),h */
case 0x04:
	Tstates += 23;
	H = RD_BYTE(XX);
	RLC(H);
	WR_BYTE(XX, H);
	break;

/* rlc (xx+d),l */
case 0x05:
	Tstates += 23;
	L = RD_BYTE(XX);
	RLC(L);
	WR_BYTE(XX, L);
	break;

/* rlc (xx+d) */
case 0x06:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	RLC(work8);
	WR_BYTE(XX, work8);
	break;

/* rlc (xx+d),a */
case 0x07:
	Tstates += 23;
	A = RD_BYTE(XX);
	RLC(A);
	WR_BYTE(XX, A);
	break;

/* rrc (xx+d),b */
case 0x08:
	Tstates += 23;
	B = RD_BYTE(XX);
	RRC(B);
	WR_BYTE(XX, B);
	break;

/* rrc (xx+d),c */
case 0x09:
	Tstates += 23;
	C = RD_BYTE(XX);
	RRC(C);
	WR_BYTE(XX, C);
	break;

/* rrc (xx+d),d */
case 0x0A:
	Tstates += 23;
	D = RD_BYTE(XX);
	RRC(D);
	WR_BYTE(XX, D);
	break;

/* rrc (xx+d),e */
case 0x0B:
	Tstates += 23;
	E = RD_BYTE(XX);
	RRC(E);
	WR_BYTE(XX, E);
	break;

/* rrc (xx+d),h */
case 0x0C:
	Tstates += 23;
	H = RD_BYTE(XX);
	RRC(H);
	WR_BYTE(XX, H);
	break;

/* rrc (xx+d),l */
case 0x0D:
	Tstates += 23;
	L = RD_BYTE(XX);
	RRC(L);
	WR_BYTE(XX, L);
	break;

/* rrc (xx+d) */
case 0x0E:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	RRC(work8);
	WR_BYTE(XX, work8);
	break;

/* rrc a */
case 0x0F:
	Tstates += 23;
	A = RD_BYTE(XX);
	RRC(A);
	WR_BYTE(XX, A);
	break;

/* rl (xx+d),b */
case 0x10:
	Tstates += 23;
	B = RD_BYTE(XX);
	RL(B);
	WR_BYTE(XX, B);
	break;

/* rl (xx+d),c */
case 0x11:
	Tstates += 23;
	C = RD_BYTE(XX);
	RL(C);
	WR_BYTE(XX, C);
	break;

/* rl (xx+d),d */
case 0x12:
	Tstates += 23;
	D = RD_BYTE(XX);
	RL(D);
	WR_BYTE(XX, D);
	break;

/* rl (xx+d),e */
case 0x13:
	Tstates += 23;
	E = RD_BYTE(XX);
	RL(E);
	WR_BYTE(XX, E);
	break;

/* rl (xx+d),h */
case 0x14:
	Tstates += 23;
	H = RD_BYTE(XX);
	RL(H);
	WR_BYTE(XX, H);
	break;

/* rl (xx+d),l */
case 0x15:
	Tstates += 23;
	L = RD_BYTE(XX);
	RL(L);
	WR_BYTE(XX, L);
	break;

/* rl (xx+d) */
case 0x16:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	RL(work8);
	WR_BYTE(XX, work8);
	break;

/* rl (xx+d),a */
case 0x17:
	Tstates += 23;
	A = RD_BYTE(XX);
	RL(A);
	WR_BYTE(XX, A);
	break;

/* rr (xx+d),b */
case 0x18:
	Tstates += 23;
	B = RD_BYTE(XX);
	RR(B);
	WR_BYTE(XX, B);
	break;

/* rr (xx+d),c */
case 0x19:
	Tstates += 23;
	C = RD_BYTE(XX);
	RR(C);
	WR_BYTE(XX, C);
	break;

/* rr (xx+d),d */
case 0x1A:
	Tstates += 23;
	D = RD_BYTE(XX);
	RR(D);
	WR_BYTE(XX, D);
	break;

/* rr (xx+d),e */
case 0x1B:
	Tstates += 23;
	E = RD_BYTE(XX);
	RR(E);
	WR_BYTE(XX, E);
	break;

/* rr (xx+d),h */
case 0x1C:
	Tstates += 23;
	H = RD_BYTE(XX);
	RR(H);
	WR_BYTE(XX, H);
	break;

/* rr (xx+d),l */
case 0x1D:
	Tstates += 23;
	L = RD_BYTE(XX);
	RR(L);
	WR_BYTE(XX, L);
	break;

/* rr (xx+d) */
case 0x1E:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	RR(work8);
	WR_BYTE(XX, work8);
	break;

/* rr (xx+d),a */
case 0x1F:
	Tstates += 23;
	A = RD_BYTE(XX);
	RR(A);
	WR_BYTE(XX, A);
	break;

/* sla (xx+d),b */
case 0x20:
	Tstates += 23;
	B = RD_BYTE(XX);
	SLA(B);
	WR_BYTE(XX, B);
	break;

/* sla (xx+d),c */
case 0x21:
	Tstates += 23;
	C = RD_BYTE(XX);
	SLA(C);
	WR_BYTE(XX, C);
	break;

/* sla (xx+d),d */
case 0x22:
	Tstates += 23;
	D = RD_BYTE(XX);
	SLA(D);
	WR_BYTE(XX, D);
	break;

/* sla (xx+d),e */
case 0x23:
	Tstates += 23;
	E = RD_BYTE(XX);
	SLA(E);
	WR_BYTE(XX, E);
	break;

/* sla (xx+d),h */
case 0x24:
	Tstates += 23;
	H = RD_BYTE(XX);
	SLA(H);
	WR_BYTE(XX, H);
	break;

/* sla (xx+d),l */
case 0x25:
	Tstates += 23;
	L = RD_BYTE(XX);
	SLA(L);
	WR_BYTE(XX, L);
	break;

/* sla (xx+d) */
case 0x26:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	SLA(work8);
	WR_BYTE(XX, work8);
	break;

/* sla (xx+d),a */
case 0x27:
	Tstates += 23;
	A = RD_BYTE(XX);
	SLA(A);
	WR_BYTE(XX, A);
	break;

/* sra (xx+d),b */
case 0x28:
	Tstates += 23;
	B = RD_BYTE(XX);
	SRA(B);
	WR_BYTE(XX, B);
	break;

/* sra (xx+d),c */
case 0x29:
	Tstates += 23;
	C = RD_BYTE(XX);
	SRA(C);
	WR_BYTE(XX, C);
	break;

/* sra (xx+d),d */
case 0x2A:
	Tstates += 23;
	D = RD_BYTE(XX);
	SRA(D);
	WR_BYTE(XX, D);
	break;

/* sra (xx+d),e */
case 0x2B:
	Tstates += 23;
	E = RD_BYTE(XX);
	SRA(E);
	WR_BYTE(XX, E);
	break;

/* sra (xx+d),h */
case 0x2C:
	Tstates += 23;
	H = RD_BYTE(XX);
	SRA(H);
	WR_BYTE(XX, H);
	break;

/* sra (xx+d),l */
case 0x2D:
	Tstates += 23;
	L = RD_BYTE(XX);
	SRA(L);
	WR_BYTE(XX, L);
	break;

/* sra (xx+d) */
case 0x2E:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	SRA(work8);
	WR_BYTE(XX, work8);
	break;

/* sra (xx+d),a */
case 0x2F:
	Tstates += 23;
	A = RD_BYTE(XX);
	SRA(A);
	WR_BYTE(XX, A);
	break;

/* The next 8 ops. are undocumented. */

/* sli (xx+d),b */
case 0x30:
	Tstates += 23;
	B = RD_BYTE(XX);
	SLI(B);
	WR_BYTE(XX, B);
	break;

/* sli (xx+d),c */
case 0x31:
	Tstates += 23;
	C = RD_BYTE(XX);
	SLI(C);
	WR_BYTE(XX, C);
	break;

/* sli (xx+d),d */
case 0x32:
	Tstates += 23;
	D = RD_BYTE(XX);
	SLI(D);
	WR_BYTE(XX, D);
	break;

/* sli (xx+d),e */
case 0x33:
	Tstates += 23;
	E = RD_BYTE(XX);
	SLI(E);
	WR_BYTE(XX, E);
	break;

/* sli (xx+d),h */
case 0x34:
	Tstates += 23;
	H = RD_BYTE(XX);
	SLI(H);
	WR_BYTE(XX, H);
	break;

/* sli (xx+d),l */
case 0x35:
	Tstates += 23;
	L = RD_BYTE(XX);
	SLI(L);
	WR_BYTE(XX, L);
	break;

/* sli (xx+d) */
case 0x36:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	SLI(work8);
	WR_BYTE(XX, work8);
	break;

/* sli (xx+d),a */
case 0x37:
	Tstates += 23;
	A = RD_BYTE(XX);
	SLI(A);
	WR_BYTE(XX, A);
	break;

/* srl (xx+d),b */
case 0x38:
	Tstates += 23;
	B = RD_BYTE(XX);
	SRL(B);
	WR_BYTE(XX, B);
	break;

/* srl (xx+d),c */
case 0x39:
	Tstates += 23;
	C = RD_BYTE(XX);
	SRL(C);
	WR_BYTE(XX, C);
	break;

/* srl (xx+d),d */
case 0x3A:
	Tstates += 23;
	D = RD_BYTE(XX);
	SRL(D);
	WR_BYTE(XX, D);
	break;

/* srl (xx+d),e */
case 0x3B:
	Tstates += 23;
	E = RD_BYTE(XX);
	SRL(E);
	WR_BYTE(XX, E);
	break;

/* srl (xx+d),h */
case 0x3C:
	Tstates += 23;
	H = RD_BYTE(XX);
	SRL(H);
	WR_BYTE(XX, H);
	break;

/* srl (xx+d),l */
case 0x3D:
	Tstates += 23;
	L = RD_BYTE(XX);
	SRL(L);
	WR_BYTE(XX, L);
	break;

/* srl (xx+d) */
case 0x3E:
	Tstates += 23;
	work8 = RD_BYTE(XX);
	SRL(work8);
	WR_BYTE(XX, work8);
	break;

/* srl (xx+d),a */
case 0x3F:
	Tstates += 23;
	A = RD_BYTE(XX);
	SRL(A);
	WR_BYTE(XX, A);
	break;

/* bit 0,(ix+d) */
case 0x40:	/* inofficial */
case 0x41:	/* inofficial */
case 0x42:	/* inofficial */
case 0x43:	/* inofficial */
case 0x44:	/* inofficial */
case 0x45:	/* inofficial */
case 0x46:
case 0x47:	/* inofficial */
	Tstates += 20;
	BIT(0, RD_BYTE(XX));
	break;

/* bit 1,(xx+d) */
case 0x48:	/* inofficial */
case 0x49:	/* inofficial */
case 0x4A:	/* inofficial */
case 0x4B:	/* inofficial */
case 0x4C:	/* inofficial */
case 0x4D:	/* inofficial */
case 0x4E:
case 0x4F:	/* inofficial */
	Tstates += 20;
	BIT(1, RD_BYTE(XX));
	break;

/* bit 2,(xx+d) */
case 0x50:	/* inofficial */
case 0x51:	/* inofficial */
case 0x52:	/* inofficial */
case 0x53:	/* inofficial */
case 0x54:	/* inofficial */
case 0x55:	/* inofficial */
case 0x56:
case 0x57:	/* inofficial */
	Tstates += 20;
	BIT(2, RD_BYTE(XX));
	break;

/* bit 3,(xx+d) */
case 0x58:	/* inofficial */
case 0x59:	/* inofficial */
case 0x5A:	/* inofficial */
case 0x5B:	/* inofficial */
case 0x5C:	/* inofficial */
case 0x5D:	/* inofficial */
case 0x5E:
case 0x5F:	/* inofficial */
	Tstates += 20;
	BIT(3, RD_BYTE(XX));
	break;

/* bit 4,(xx+d) */
case 0x60:	/* inofficial */
case 0x61:	/* inofficial */
case 0x62:	/* inofficial */
case 0x63:	/* inofficial */
case 0x64:	/* inofficial */
case 0x65:	/* inofficial */
case 0x66:
case 0x67:	/* inofficial */
	Tstates += 20;
	BIT(4, RD_BYTE(XX));
	break;

/* bit 5,(xx+d) */
case 0x68:	/* inofficial */
case 0x69:	/* inofficial */
case 0x6A:	/* inofficial */
case 0x6B:	/* inofficial */
case 0x6C:	/* inofficial */
case 0x6D:	/* inofficial */
case 0x6E:
case 0x6F:	/* inofficial */
	Tstates += 20;
	BIT(5, RD_BYTE(XX));
	break;

/* bit 6,(xx+d) */
case 0x70:	/* inofficial */
case 0x71:	/* inofficial */
case 0x72:	/* inofficial */
case 0x73:	/* inofficial */
case 0x74:	/* inofficial */
case 0x75:	/* inofficial */
case 0x76:
case 0x77:	/* inofficial */
	Tstates += 20;
	BIT(6, RD_BYTE(XX));
	break;

/* bit 7,(xx+d) */
case 0x78:	/* inofficial */
case 0x79:	/* inofficial */
case 0x7A:	/* inofficial */
case 0x7B:	/* inofficial */
case 0x7C:	/* inofficial */
case 0x7D:	/* inofficial */
case 0x7E:
case 0x7F:	/* inofficial */
	Tstates += 20;
	BIT(7, RD_BYTE(XX));
	S_FLAG = Z_FLAG ? S_FLAG : 1;
	break;

/* res 0,(xx+d),b */
case 0x80:
	Tstates += 23;
	B = RD_BYTE(XX) & 0xfe;
	WR_BYTE(XX, B);
	break;

/* res 0,(xx+d),c */
case 0x81:
	Tstates += 23;
	C = RD_BYTE(XX) & 0xfe;
	WR_BYTE(XX, C);
	break;

/* res 0,(xx+d),d */
case 0x82:
	Tstates += 23;
	D = RD_BYTE(XX) & 0xfe;
	WR_BYTE(XX, D);
	break;

/* res 0,(xx+d),e */
case 0x83:
	Tstates += 23;
	E = RD_BYTE(XX) & 0xfe;
	WR_BYTE(XX, E);
	break;

/* res 0,(xx+d),h */
case 0x84:
	Tstates += 23;
	H = RD_BYTE(XX) & 0xfe;
	WR_BYTE(XX, H);
	break;

/* res 0,(xx+d),l */
case 0x85:
	Tstates += 23;
	L = RD_BYTE(XX) & 0xfe;
	WR_BYTE(XX, L);
	break;

/* res 0,(xx+d) */
case 0x86:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0xfe);
	break;

/* res 0,(xx+d),a */
case 0x87:
	Tstates += 23;
	A = RD_BYTE(XX) & 0xfe;
	WR_BYTE(XX, A);
	break;

/* res 1,(xx+d),b */
case 0x88:
	Tstates += 23;
	B = RD_BYTE(XX) & 0xfd;
	WR_BYTE(XX, B);
	break;

/* res 1,(xx+d),c */
case 0x89:
	Tstates += 23;
	C = RD_BYTE(XX) & 0xfd;
	WR_BYTE(XX, C);
	break;

/* res 1,(xx+d),d */
case 0x8A:
	Tstates += 23;
	D = RD_BYTE(XX) & 0xfd;
	WR_BYTE(XX, D);
	break;

/* res 1,(xx+d),e */
case 0x8B:
	Tstates += 23;
	E = RD_BYTE(XX) & 0xfd;
	WR_BYTE(XX, E);
	break;

/* res 1,(xx+d),h */
case 0x8C:
	Tstates += 23;
	H = RD_BYTE(XX) & 0xfd;
	WR_BYTE(XX, H);
	break;

/* res 1,(xx+d),l */
case 0x8D:
	Tstates += 23;
	L = RD_BYTE(XX) & 0xfd;
	WR_BYTE(XX, L);
	break;

/* res 1,(xx+d) */
case 0x8E:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0xfd);
	break;

/* res 1,(xx+d),a */
case 0x8F:
	Tstates += 23;
	A = RD_BYTE(XX) & 0xfd;
	WR_BYTE(XX, A);
	break;

/* res 2,(xx+d),b */
case 0x90:
	Tstates += 23;
	B = RD_BYTE(XX) & 0xfb;
	WR_BYTE(XX, B);
	break;

/* res 2,(xx+d),c */
case 0x91:
	Tstates += 23;
	C = RD_BYTE(XX) & 0xfb;
	WR_BYTE(XX, C);
	break;

/* res 2,(xx+d),d */
case 0x92:
	Tstates += 23;
	D = RD_BYTE(XX) & 0xfb;
	WR_BYTE(XX, D);
	break;

/* res 2,(xx+d),e */
case 0x93:
	Tstates += 23;
	E = RD_BYTE(XX) & 0xfb;
	WR_BYTE(XX, E);
	break;

/* res 2,(xx+d),h */
case 0x94:
	Tstates += 23;
	H = RD_BYTE(XX) & 0xfb;
	WR_BYTE(XX, H);
	break;

/* res 2,(xx+d),l */
case 0x95:
	Tstates += 23;
	L = RD_BYTE(XX) & 0xfb;
	WR_BYTE(XX, L);
	break;

/* res 2,(xx+d) */
case 0x96:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0xfb);
	break;

/* res 2,(xx+d),a */
case 0x97:
	Tstates += 23;
	A = RD_BYTE(XX) & 0xfb;
	WR_BYTE(XX, A);
	break;

/* res 3,(xx+d),b */
case 0x98:
	Tstates += 23;
	B = RD_BYTE(XX) & 0xf7;
	WR_BYTE(XX, B);
	break;

/* res 3,(xx+d),c */
case 0x99:
	Tstates += 23;
	C = RD_BYTE(XX) & 0xf7;
	WR_BYTE(XX, C);
	break;

/* res 3,(xx+d),d */
case 0x9A:
	Tstates += 23;
	D = RD_BYTE(XX) & 0xf7;
	WR_BYTE(XX, D);
	break;

/* res 3,(xx+d),e */
case 0x9B:
	Tstates += 23;
	E = RD_BYTE(XX) & 0xf7;
	WR_BYTE(XX, E);
	break;

/* res 3,(xx+d),h */
case 0x9C:
	Tstates += 23;
	H = RD_BYTE(XX) & 0xf7;
	WR_BYTE(XX, H);
	break;

/* res 3,(xx+d),l */
case 0x9D:
	Tstates += 23;
	L = RD_BYTE(XX) & 0xf7;
	WR_BYTE(XX, L);
	break;

/* res 3,(xx+d) */
case 0x9E:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0xf7);
	break;

/* res 3,(xx+d),a */
case 0x9F:
	Tstates += 23;
	A = RD_BYTE(XX) & 0xf7;
	WR_BYTE(XX, A);
	break;

/* res 4,(xx+d),b */
case 0xA0:
	Tstates += 23;
	B = RD_BYTE(XX) & 0xef;
	WR_BYTE(XX, B);
	break;

/* res 4,(xx+d),c */
case 0xA1:
	Tstates += 23;
	C = RD_BYTE(XX) & 0xef;
	WR_BYTE(XX, C);
	break;

/* res 4,(xx+d),d */
case 0xA2:
	Tstates += 23;
	D = RD_BYTE(XX) & 0xef;
	WR_BYTE(XX, D);
	break;

/* res 4,(xx+d),e */
case 0xA3:
	Tstates += 23;
	E = RD_BYTE(XX) & 0xef;
	WR_BYTE(XX, E);
	break;

/* res 4,(xx+d),h */
case 0xA4:
	Tstates += 23;
	H = RD_BYTE(XX) & 0xef;
	WR_BYTE(XX, H);
	break;

/* res 4,(xx+d),l */
case 0xA5:
	Tstates += 23;
	L = RD_BYTE(XX) & 0xef;
	WR_BYTE(XX, L);
	break;

/* res 4,(xx+d) */
case 0xA6:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0xef);
	break;

/* res 4,(xx+d),a */
case 0xA7:
	Tstates += 23;
	A = RD_BYTE(XX) & 0xef;
	WR_BYTE(XX, A);
	break;

/* res 5,(xx+d),b */
case 0xA8:
	Tstates += 23;
	B = RD_BYTE(XX) & 0xdf;
	WR_BYTE(XX, B);
	break;

/* res 5,(xx+d),c */
case 0xA9:
	Tstates += 23;
	C = RD_BYTE(XX) & 0xdf;
	WR_BYTE(XX, C);
	break;

/* res 5,(xx+d),d */
case 0xAA:
	Tstates += 23;
	D = RD_BYTE(XX) & 0xdf;
	WR_BYTE(XX, D);
	break;

/* res 5,(xx+d),e */
case 0xAB:
	Tstates += 23;
	E = RD_BYTE(XX) & 0xdf;
	WR_BYTE(XX, E);
	break;

/* res 5,(xx+d),h */
case 0xAC:
	Tstates += 23;
	H = RD_BYTE(XX) & 0xdf;
	WR_BYTE(XX, H);
	break;

/* res 5,(xx+d),l */
case 0xAD:
	Tstates += 23;
	L = RD_BYTE(XX) & 0xdf;
	WR_BYTE(XX, L);
	break;

/* res 5,(xx+d) */
case 0xAE:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0xdf);
	break;

/* res 5,(xx+d),a */
case 0xAF:
	Tstates += 23;
	A = RD_BYTE(XX) & 0xdf;
	WR_BYTE(XX, A);
	break;

/* res 6,(xx+d),b */
case 0xB0:
	Tstates += 23;
	B = RD_BYTE(XX) & 0xbf;
	WR_BYTE(XX, B);
	break;

/* res 6,(xx+d),c */
case 0xB1:
	Tstates += 23;
	C = RD_BYTE(XX) & 0xbf;
	WR_BYTE(XX, C);
	break;

/* res 6,(xx+d),d */
case 0xB2:
	Tstates += 23;
	D = RD_BYTE(XX) & 0xbf;
	WR_BYTE(XX, D);
	break;

/* res 6,(xx+d),e */
case 0xB3:
	Tstates += 23;
	E = RD_BYTE(XX) & 0xbf;
	WR_BYTE(XX, E);
	break;

/* res 6,(xx+d),h */
case 0xB4:
	Tstates += 23;
	H = RD_BYTE(XX) & 0xbf;
	WR_BYTE(XX, H);
	break;

/* res 6,(xx+d),l */
case 0xB5:
	Tstates += 23;
	L = RD_BYTE(XX) & 0xbf;
	WR_BYTE(XX, L);
	break;

/* res 6,(xx+d) */
case 0xB6:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0xbf);
	break;

/* res 6,(xx+d),a */
case 0xB7:
	Tstates += 23;
	A = RD_BYTE(XX) & 0xbf;
	WR_BYTE(XX, A);
	break;

/* res 7,(xx+d),b */
case 0xB8:
	Tstates += 23;
	B = RD_BYTE(XX) & 0x7f;
	WR_BYTE(XX, B);
	break;

/* res 7,(xx+d),c */
case 0xB9:
	Tstates += 23;
	C = RD_BYTE(XX) & 0x7f;
	WR_BYTE(XX, C);
	break;

/* res 7,(xx+d),d */
case 0xBA:
	Tstates += 23;
	D = RD_BYTE(XX) & 0x7f;
	WR_BYTE(XX, D);
	break;

/* res 7,(xx+d),e */
case 0xBB:
	Tstates += 23;
	E = RD_BYTE(XX) & 0x7f;
	WR_BYTE(XX, E);
	break;

/* res 7,(xx+d),h */
case 0xBC:
	Tstates += 23;
	H = RD_BYTE(XX) & 0x7f;
	WR_BYTE(XX, H);
	break;

/* res 7,(xx+d),l */
case 0xBD:
	Tstates += 23;
	L = RD_BYTE(XX) & 0x7f;
	WR_BYTE(XX, L);
	break;

/* res 7,(xx+d) */
case 0xBE:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) & 0x7f);
	break;

/* res 7,(xx+d),a */
case 0xBF:
	Tstates += 23;
	A = RD_BYTE(XX) & 0x7f;
	WR_BYTE(XX, A);
	break;

/* set 0,(xx+d),b */
case 0xC0:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x1;
	WR_BYTE(XX, B);
	break;

/* set 0,(xx+d),c */
case 0xC1:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x1;
	WR_BYTE(XX, C);
	break;

/* set 0,(xx+d),d */
case 0xC2:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x1;
	WR_BYTE(XX, D);
	break;

/* set 0,(xx+d),e */
case 0xC3:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x1;
	WR_BYTE(XX, E);
	break;

/* set 0,(xx+d),h */
case 0xC4:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x1;
	WR_BYTE(XX, H);
	break;

/* set 0,(xx+d),l */
case 0xC5:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x1;
	WR_BYTE(XX, L);
	break;

/* set 0,(xx+d) */
case 0xC6:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x01);
	break;

/* set 0,(xx+d),a */
case 0xC7:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x1;
	WR_BYTE(XX, A);
	break;

/* set 1,(xx+d),b */
case 0xC8:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x2;
	WR_BYTE(XX, B);
	break;

/* set 1,(xx+d),c */
case 0xC9:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x2;
	WR_BYTE(XX, C);
	break;

/* set 1,(xx+d),d */
case 0xCA:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x2;
	WR_BYTE(XX, D);
	break;

/* set 1,(xx+d),e */
case 0xCB:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x2;
	WR_BYTE(XX, E);
	break;

/* set 1,(xx+d),h */
case 0xCC:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x2;
	WR_BYTE(XX, H);
	break;

/* set 1,(xx+d),l */
case 0xCD:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x2;
	WR_BYTE(XX, L);
	break;

/* set 1,(xx+d) */
case 0xCE:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x02);
	break;

/* set 1,(xx+d),a */
case 0xCF:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x2;
	WR_BYTE(XX, A);
	break;

/* set 2,(xx+d),b */
case 0xD0:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x4;
	WR_BYTE(XX, B);
	break;

/* set 2,(xx+d),c */
case 0xD1:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x4;
	WR_BYTE(XX, C);
	break;

/* set 2,(xx+d),d */
case 0xD2:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x4;
	WR_BYTE(XX, D);
	break;

/* set 2,(xx+d),e */
case 0xD3:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x4;
	WR_BYTE(XX, E);
	break;

/* set 2,(xx+d),h */
case 0xD4:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x4;
	WR_BYTE(XX, H);
	break;

/* set 2,(xx+d),l */
case 0xD5:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x4;
	WR_BYTE(XX, L);
	break;

/* set 2,(xx+d) */
case 0xD6:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x04);
	break;

/* set 2,(xx+d),a */
case 0xD7:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x4;
	WR_BYTE(XX, A);
	break;

/* set 3,(xx+d),b */
case 0xD8:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x8;
	WR_BYTE(XX, B);
	break;

/* set 3,(xx+d),c */
case 0xD9:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x8;
	WR_BYTE(XX, C);
	break;

/* set 3,(xx+d),d */
case 0xDA:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x8;
	WR_BYTE(XX, D);
	break;

/* set 3,(xx+d),e */
case 0xDB:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x8;
	WR_BYTE(XX, E);
	break;

/* set 3,(xx+d),h */
case 0xDC:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x8;
	WR_BYTE(XX, H);
	break;

/* set 3,(xx+d),l */
case 0xDD:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x8;
	WR_BYTE(XX, L);
	break;

/* set 3,(xx+d) */
case 0xDE:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x08);
	break;

/* set 3,(xx+d),a */
case 0xDF:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x8;
	WR_BYTE(XX, A);
	break;

/* set 4,(xx+d),b */
case 0xE0:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x10;
	WR_BYTE(XX, B);
	break;

/* set 4,(xx+d),c */
case 0xE1:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x10;
	WR_BYTE(XX, C);
	break;

/* set 4,(xx+d),d */
case 0xE2:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x10;
	WR_BYTE(XX, D);
	break;

/* set 4,(xx+d),e */
case 0xE3:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x10;
	WR_BYTE(XX, E);
	break;

/* set 4,(xx+d),h */
case 0xE4:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x10;
	WR_BYTE(XX, H);
	break;

/* set 4,(xx+d),l */
case 0xE5:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x10;
	WR_BYTE(XX, L);
	break;

/* set 4,(xx+d) */
case 0xE6:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x10);
	break;

/* set 4,(xx+d),a */
case 0xE7:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x10;
	WR_BYTE(XX, A);
	break;

/* set 5,(xx+d),b */
case 0xE8:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x20;
	WR_BYTE(XX, B);
	break;

/* set 5,(xx+d),c */
case 0xE9:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x20;
	WR_BYTE(XX, C);
	break;

/* set 5,(xx+d),d */
case 0xEA:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x20;
	WR_BYTE(XX, D);
	break;

/* set 5,(xx+d),e */
case 0xEB:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x20;
	WR_BYTE(XX, E);
	break;

/* set 5,(xx+d),h */
case 0xEC:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x20;
	WR_BYTE(XX, H);
	break;

/* set 5,(xx+d),l */
case 0xED:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x20;
	WR_BYTE(XX, L);
	break;

/* set 5,(xx+d) */
case 0xEE:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x20);
	break;

/* set 5(xx+d),,a */
case 0xEF:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x20;
	WR_BYTE(XX, A);
	break;

/* set 6,(xx+d),b */
case 0xF0:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x40;
	WR_BYTE(XX, B);
	break;

/* set 6,(xx+d),c */
case 0xF1:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x40;
	WR_BYTE(XX, C);
	break;

/* set 6,(xx+d),d */
case 0xF2:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x40;
	WR_BYTE(XX, D);
	break;

/* set 6,(xx+d),e */
case 0xF3:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x40;
	WR_BYTE(XX, E);
	break;

/* set 6,(xx+d),h */
case 0xF4:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x40;
	WR_BYTE(XX, H);
	break;

/* set 6,(xx+d),l */
case 0xF5:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x40;
	WR_BYTE(XX, L);
	break;

/* set 6,(xx+d) */
case 0xF6:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x40);
	break;

/* set 6,(xx+d),a */
case 0xF7:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x40;
	WR_BYTE(XX, A);
	break;

/* set 7,(xx+d),b */
case 0xF8:
	Tstates += 23;
	B = RD_BYTE(XX) | 0x80;
	WR_BYTE(XX, B);
	break;

/* set 7,(xx+d),c */
case 0xF9:
	Tstates += 23;
	C = RD_BYTE(XX) | 0x80;
	WR_BYTE(XX, C);
	break;

/* set 7,(xx+d),d */
case 0xFA:
	Tstates += 23;
	D = RD_BYTE(XX) | 0x80;
	WR_BYTE(XX, D);
	break;

/* set 7,(xx+d),e */
case 0xFB:
	Tstates += 23;
	E = RD_BYTE(XX) | 0x80;
	WR_BYTE(XX, E);
	break;

/* set 7,(xx+d),h */
case 0xFC:
	Tstates += 23;
	H = RD_BYTE(XX) | 0x80;
	WR_BYTE(XX, H);
	break;

/* set 7,(xx+d),l */
case 0xFD:
	Tstates += 23;
	L = RD_BYTE(XX) | 0x80;
	WR_BYTE(XX, L);
	break;

/* set 7,(xx+d) */
case 0xFE:
	Tstates += 23;
	WR_BYTE(XX, RD_BYTE(XX) | 0x80);
	break;

/* set 7,(xx+d),a */
case 0xFF:
	Tstates += 23;
	A = RD_BYTE(XX) | 0x80;
	WR_BYTE(XX, A);
	break;

/* EOF *************************************************************************/
